package Common;

use strict;
no warnings;

require Exporter;
use base qw/Exporter/;

our @EXPORT = qw(debug loadf writef genran msleep rnd loadcfg);

sub genran($)
{
	my $res;
	my @list = (48..57, 65..90, 97..122);
	$res .= chr($list[rand @list]) for 1..$_[0];
	return $res;
}

sub debug($) 
{
	my (undef, undef, undef, $day, undef, undef, undef, undef, undef) = localtime(time);
	open F, '>>', $day.'_debug.txt';
	print F 'Time: '.scalar localtime(time)."\n".$_[0]."\n";
	close F;
}

sub loadf($)
{
	open F, '<', $_[0] or die "$_[0] - $!\n";
	chomp(my @list = <F>);
	close F;
	return @list;
}

sub writef($$$)
{
	if($_[2])
	{
		open F, '>', $_[0] or warn "$_[0] - $!\n";
	}
	else
	{
		open F, '>>', $_[0] or warn "$_[0] - $!\n";
	}
	print F $_[1];
	close F;
}

sub msleep($)
{
	select undef, undef, undef, $_[0];
}

sub rnd($$)
{
	return $_[0] + int rand $_[1] - $_[0] + 1;
}

sub loadcfg($)
{
	open F, '<', $_[0] or die "Can't load config file - $_[0]\n";
	chomp(my @list = <F>);
	close F;

	my %cfg = map { /^(\w+)=(.+)$/ && $1 => $2 } @list;
	return %cfg;
}

1;