package iStr;

use strict;
no warnings;

require Exporter;
use base qw/Exporter/;

our @EXPORT = qw(replace_char friendly_name mix_str);

sub replace_char
{
	my ($str, $r) = @_;
 
	my %rep = (
			'а' => 'a', 'А' => 'A', 'В' => 'B', 'е' => 'e', 'Е' => 'E',
			'о' => 'o', 'О' => 'O', 'р' => 'p', 'Р' => 'P', 'Н' => 'H',
			'и' => 'u', 'Т' => 'T', 'с' => 'c', 'С' => 'C', 'М' => 'M',
			'К' => 'K', 'х' => 'x', 'Х' => 'X',
			);
 
	my $res;

	for my $char(split //, $str)
	{
		if(int rand 2 && $rep{$char} && $r > 0) #Да, да, может не состояться ни одной замены
		{
			$res .= $rep{$char};
			$r--;
		}
		else
		{
			$res .= $char;
		}
	}

	undef %rep;

	return $res;
}

sub friendly_name
{
	my ($name) = @_;
 
	my %names = (
	'Алексей'=>'Лёх','Александр'=>'Санек','Александра'=>'Саша','Анатолий'=>'Толик','Андрей'=>'Андрюх',
	'Антон'=>'Тоха','Борис'=>'Борь','Валерий'=>'Валер','Василий'=>'Васек','Виктор'=>'Вить',
	'Владимир'=>'Володь','Евгений'=>'Жека','Геннадий'=>'Ген','Дмитрий'=>'Диман','Иван'=>'Ванек',
	'Сергей'=>'Серег','Костян'=>'Кость','Денис'=>'Ден','Леонид'=>'Лен','Максим'=>'Макс','Мирослав'=>'Мирик',
	'Михаил'=>'Миш','Анастасия'=>'Насть','Анна'=>'Ань','Валентина'=>'Валь','Вера'=>'Вер','Виктория'=>'Вик',
	'Галина'=>'Галь','Дарья'=>'Дашь','Евгения'=>'Жень','Екатерина'=>'Кать','Елена'=>'Лен','Ирина'=>'Ирин',
	'Ксения'=>'Ксюшь','Лариса'=>'Ларис','Марина'=>'Марин','Мария'=>'Машь','Надежда'=>'Надь',
	'Наталья'=>'Наташь','Нина'=>'Нин','Оксана'=>'Оксан','Олеся'=>'Олесь','Ольга'=>'Оль','Полина'=>'Полин',
	'Светлана'=>'Свет','Таня'=>'Тань','Юлия'=>'Юль','Яна'=>'Ян','Кристина'=>'Кристин');
 
	$name = $names{$name} ? $names{$name} : $name;
	undef %names;
	
	return $name;
}

sub mix_str
{
	my ($str) = @_;
	$str =~ s#\{(.+?)\}#(split /\|/, $1)[rand 1 + ($1 =~ tr/|//)]#eg; #{} ...
	return $str;
}

1;